/*
** Public user to view Course/Class schedule
** Class: PublicPage
** Author: Yuping Zhu
** Date: 03-12-1999
** Modified: 08-13-1999
** 		Add student to view Enrollment
*/

package ascdb.pub;

// import package java.sql to use JDBC
import java.sql.*;

// import oracle.html and javax.servlet package to generate dynamic HTML page
import oracle.html.*;
import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;
import ascdb.conf;
import ascdb.pub.UserCheck;

public class PublicPage extends HttpServlet {
	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException, IOException
	{
	
        // Output HTML page header
        res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	conf dbconf= new conf(req);
	int op = (new Integer(req.getParameter("op"))).intValue();

	String uid = req.getParameter("me");
	UserCheck u = new UserCheck(uid);	

	String tit;

	// Class List
	if ( op == 0) 
		tit = "Training Class Schedule";
	else
		tit = "Training Class List";
	
       try {
	  // Creates an HtmlHead Object
	HtmlHead hd = new HtmlHead("Course Schedule");
	
        // Create an HtmlBody Object
	HtmlBody bd = new HtmlBody();

	// Sets various attributes of HtmlBody
     	bd.setBackgroundColor("#fffff2");

	// Creates an HtmlPage object using hd and bd
	HtmlPage hp = new HtmlPage(hd, bd);

	// Modify or Delete a class
	if (( op == 5 ) | (op == 6))	
	   if (u.UserRole(1) != 0 )
	   {
		hp.addItem(new SimpleItem("You do not have this privilege!").setBold());
		out.println(hp);
		return;
	   }
	   else if (op == 5)
	  	hp.addItem(new SimpleItem("Click on Class_ID to modify the class ...").setBold().setFontColor(Color.red));
	   else
		hp.addItem(new SimpleItem("Click on Class_ID to delete the class ...").setBold().setFontColor(Color.red));


	
	// Register the class
	if (op == 2) 
	   if ((u.UserRole(1) != 0) & (u.UserRole(2) !=  0) & (u.UserRole(3) != 0) & (u.UserRole(4) != 0))
	   {
		hp.addItem(new SimpleItem("You do not have this privilege!"));
		out.println(hp);
		return;
	   }
	   else
		hp.addItem(new SimpleItem("Click on Class_ID to register for the class ...").setBold().setFontColor(Color.red));

	// View Enrollment
	if (op == 3) 
	
	// Add student to view enrollment

	 /*  if ((u.UserRole(1) != 0) & (u.UserRole(2) !=  0) & (u.UserRole(3) != 0))
	   {
		hp.addItem(new SimpleItem("You do not have this privilege!").setBold());
		out.println(hp);
		return;
	   }
	   else*/
		hp.addItem(new SimpleItem("Click on Class_ID to view the class roster ...").setBold().setFontColor(Color.red));
	
	
	Font f = new Font(Color.olive,"myfont","+5");
	
 
	hp
	  .addItem(new SimpleItem(f.toHTML()))
	  .addItem(new SimpleItem(tit).setCenter())
	  .addItem(SimpleItem.HorizontalRule);
	
	Font bf = new Font(Color.black,null,"+1");
	hp.addItem(new SimpleItem(bf.toHTML()));

	// Load the Oracle JDBC driver
	Class.forName (dbconf.JdbcDriver);

	// Connect to the database
	Connection conn =
		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);
	
	// Create a Statement
	Statement stmt = conn.createStatement ();
	
        // get class count
	String QueryStr = "select count(*) from simple_class";
	ResultSet  tot = stmt.executeQuery(QueryStr);
	
	int ClassTot = 0;
	if (tot.next())
		ClassTot = tot.getInt(1);
	if (ClassTot == 0)
	{
		hp.addItem(new SimpleItem("No Class in Database").setBold().setCenter());
	        out.println(hp);
		return;
	}
	tot.close();

	// Get all classes from Traning DB
	String QueryString = "select * from simple_class  order by class_start_date desc";
	// execute query
        ResultSet rset = stmt.executeQuery (QueryString);
	
	//Creates the table with 6 columns
      	DynamicTable tab = new DynamicTable(6);
	tab.setBackgroundColor (Color.pink);
        tab.setBorderColor (Color.navy);
	tab.setCellSpacing(2);
	tab.setCellPadding(5);
	
	TableRow[] rows = new TableRow[ClassTot + 1];
	for(int i=0; i <= ClassTot; i++)
	    rows[i] = new TableRow();
	rows[0]
	  .addCell(new TableDataCell(new SimpleItem("Class_ID").setBold().setFontColor(Color.maroon))) 
	  .addCell(new TableDataCell(new SimpleItem("Course_Num").setBold().setFontColor(Color.maroon)))
	  .addCell(new TableDataCell(new SimpleItem("Title").setBold().setFontColor(Color.maroon)))
	  .addCell(new TableDataCell(new SimpleItem("Class Size").setBold().setFontColor(Color.maroon)))
	  .addCell(new TableDataCell(new SimpleItem("Start Date (yyyy-mm-dd)").setBold().setFontColor(Color.maroon)))
	  .addCell(new TableDataCell(new SimpleItem("Duration").setBold().setFontColor(Color.maroon)));
	
	//Create table by listing all course from courses
	int i = 1;
	while (rset.next())
	{
	  if ((op == 0) | (op == 1))
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.pub.ClassDetail?cid=" + rset.getInt("class_id"), new SimpleItem(rset.getString("class_id")).setBold())));
	  else if (op == 2)
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.classes.RegisterClass?cid=" + rset.getInt("class_id") + "&me=" + uid, new SimpleItem(rset.getString("class_id")).setBold())));
	  else if (op == 3)
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.classes.Enrollment?cid=" + rset.getInt("class_id") + "&me=" + uid, new SimpleItem(rset.getString("class_id")).setBold())));
	  else if (op == 5)
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.classes.ClassModify?cid=" + rset.getInt("class_id") + "&me=" +uid, new SimpleItem(rset.getString("class_id")).setBold())));
	  else if (op == 6)
	    rows[i]
		.addCell(new TableDataCell(new Link("ascdb.classes.ClassDelete?cid=" + rset.getInt("class_id") + "&me=" + uid, new SimpleItem(rset.getString("class_id")).setBold())));
	  rows[i++]
		.addCell(new TableDataCell(new SimpleItem(rset.getString("course_num")).setBold()))
		.addCell(new TableDataCell(new SimpleItem(rset.getString("title")).setBold()))
		.addCell(new TableDataCell(new SimpleItem(rset.getString("class_size")).setBold()))
		.addCell(new TableDataCell(new SimpleItem(rset.getDate("class_start_date").toString()).setBold()))
//		.addCell(new TableDataCell(new SimpleItem((rset.getDate("class_start_date")).toString() + " (yyyy-mm-dd)")))
		.addCell(new TableDataCell(new SimpleItem(rset.getString("duration")).setBold()));
	}

	hp.addItem(new SimpleItem("Total: " + ClassTot).setCenter().setItal().setFontColor(Color.orange).setBold());

	//       Add new row to table
	for(i=0; i< ClassTot + 1; i++)
	    tab.addRow(rows[i]);

	// Add the table to Html Body
	bd.addItem(tab.setCenter());
	
	bd
	 .addItem(SimpleItem.Paragraph)
	 .addItem(SimpleItem.HorizontalRule)
	 .addItem(SimpleItem.Paragraph);

	if (op == 0 )
	{	
	Form frm = new Form("GET","ascdb.pub.UserRegister");
	frm
	  .addItem(new SimpleItem("If you want to take class and you are not a Training System user, please register now...").setBold().setFontColor(Color.orange))
	  .addItem(SimpleItem.LineBreak)
	  .addItem(new Submit("submit", "Register!"));
	
	// Add form to html body
	bd.addItem(frm.setCenter());
	}
	// output HTML page
	out.println(hp);
//	hp.printHeader();
//	hp.print();
        }
	catch(ClassNotFoundException e) {
	out.println("Couldn't load database driver: " + e.getMessage());
        }
        catch (SQLException e) { 
	out.println(e.getMessage());
	}
	catch(Exception e) {
	out.println(e.getMessage());
	}
    }
    public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {doPost(req,res);}
}

